<?php

  #===========================================
  # Silnik tego skryptu zapoyczony zosta z czytnika RSS w wersji PHP z
  # oprogramowania RSS GET, oryginalna wersja programu na stronie: http://www.aarondunlap.com
  #===========================================

  $czas = 20; // Co ile ma by aktualizacja
  
  $folder = "".INFUSIONS."rss_reader_panel1/rss1/"; // Adres folderu, w ktrym znajdowa si bd pliki z newsami.
  
  $adres = "http://rss.gazeta.pl/pub/rss/wiadomosci.xml"; // Adres URL do kanau RSS
  $nazwa_kanalu = "<span style='color:brown'>Informacje z Gazeta PL - Kraj</span>"; // Tytu kanau RSS
  $liczba = 5; // Iloc nagwkw newsw, ktre maj by wyswietlane
  $target = "_blank"; // Opcja target="" dla newsw, moliwe: "_self" oraz "_blank"
  $autoupdate = TRUE;
  $trunc = FALSE;
  $delim = FALSE;
  
  if (isset($_GET['rssHeadline'])) { $rssHeadline = $_GET['rssHeadline'];}
  $basefile = $folder;
  $folder .= md5($adres).".html"; // Przygotowywanie nazw plikw dla danego kanau

  #==========================
  # Operacje zwizane ze sprawdzaniem aktualnoci nagwkw w pliku tekstowym
  #==========================

  if (($czas > 0) && (is_file($folder)) && (((time()-filemtime($folder)) < ($czas * 60)))) {
  	include $folder;
	$time = floor((time()-filemtime($folder)) / 60); // Sprawdza ile minut temu plik by aktualizowany
       
  } elseif (@fopen($adres,"r")) { // Sprawdza czy ma dostp do kanau RSS

  	  #==========================
	  # Operacja zwizane z dodawaniem nowego nagwka do pliku
	  #==========================

	  $rssHandle = fopen($adres,"r") ; // Otwiera plik kanau RSS

	  while (!feof($rssHandle)) {
	  	$rssData .= fgets($rssHandle);
	  }

	  #==========================
	  # Przygotowywanie newsa do wczenia do pliku
	  #==========================
	  $tag = "item ";
	  $rssData =  preg_replace("/<" . $tag . "(.|\s)*?>/","<item>",$rssData);
	  $rssData = chop($rssData); // Usuwanie pustych spacji z koca linijek   
	  $rssData = ereg_replace("[\r\n]", "", $rssData); // Usuwwanie pustych linijek
	  $rssData = strstr($rssData,"<item>"); // Usuwanie wszystie przez <item>.

	  #==========================
	  # Usuwanie zbdnych elemntw tak aby okrojona zawarto moga zosta zapisana w pliku

	  # Tagi <description></description> zostaj pominite
	  #==========================	  
	  $tags_and_content_to_strip = Array("description");

	  foreach ($tags_and_content_to_strip as $tag) {
	       $rssData = preg_replace("/<" . $tag . ">(.|\s)*?<\/" . $tag . ">/","",$rssData);
	  }

	  $rssData = str_replace("<item>","", $rssData); // usuwanie tagu <item>
	  $rssData = urldecode($rssData); // Zamiana wszystkich: %20 na spacje.
	  $rssData = str_replace(strstr("</channel>",$rssData),"",$rssData);
	  $rssArray = explode("</item>",$rssData); // Tworzenie tablicy z nagwkami
  
  	  $title = array();
	  $link = array();

	  #==========================
	  # Ten mechanizm tworzy tablice dla linkw oraz nagwkw
	  #==========================  
	  $x = 0;
	  while($x < $liczba) {
  		$link[$x] = strstr($rssArray[$x],"<link>"); // usuwanie wszystkiego przed <link>
		$link[$x] = ereg_replace("<link>","",$link[$x]); 
 		$link[$x] = str_replace(strstr($link[$x],"</link>"),"",$link[$x]);
	 	$link[$x] = trim($link[$x]);
		$title[$x] = strstr($rssArray[$x],"<title>");
  		$title[$x] = ereg_replace("<title>","",$title[$x]); // Usuwanie <title> z czci tytuu newsa
	  	$title[$x] = str_replace(strstr($title[$x],"</title>"),"",$title[$x]); //  Usuwanie </title> oraz wszystkiego poza nim
	  	$title[$x] = trim($title[$x]);
		
		if ($trunc != FALSE) { $title[$x] = str_replace(substr($title[$x],$trunc),"",$title[$x]); }
		if ($delim != FALSE) { $title[$x] = str_replace(strstr($title[$x],$delim),"",$title[$x]); }
        
        	if ($title[$x] == "") { $liczba = $x; break; } // Gdy ju nie ma nagwkw zmienna $liczba przyjmuje warto maksumaln.
		$x++;
	  }

	  #==========================
	  # Zapis do pliku
	  #==========================
	  $fp = fopen($folder, "w+");
	  $x=0;  
	  fwrite($fp,"<b><span class=\"displayname\">$nazwa_kanalu</span></b> \n"); // zapisywanie do pliku

	  while ($x < $liczba) { // ta ptla zapisuje kady link osobno.
  		fwrite($fp,"<br>\n<img src='".THEME."images/bullet.gif' alt=''> <a class=\"headlinellink\" target=\"$target\" href=\"$link[$x]\">$title[$x]</a>");
		$x++;
	  }
	 fclose($fp);
	 include $folder;

 } else { 
	#==========================
	# Zwracanie bdu gdy podany adres jest bdny.
	#==========================
	echo "<b>Nie mozna poczy si z adresem: $adres. </b>";

}

?>
